// expose project build information

'use strict'

var buildDescription = 'unable to determine build id'

try {
  const spawnSync = require('child_process').spawnSync

  // get current status of git repo
  const gitDescribe = spawnSync('git', 'describe --long --dirty --tags'.split(' '))
  if (gitDescribe.error) { throw gitDescribe.error }

  buildDescription = String(gitDescribe.stdout).trim()
} catch (e) {
  // no git probably
  buildDescription = require('../../package.json').version
}

module.exports = {
  describe: buildDescription
}
