'use strict'

exports.handleRequest = handleRequest

// Handle the HTTP request
function handleRequest (req, res) {
  const context = req.nsStorage.context
  const qData = req.nsStorage.qData

  context.agentManager.list().map((agent) => {
    if (qData.id && agent.id !== qData.id) return
    if (qData.hostname && agent.tags.hostname !== qData.hostname) return
    if (qData.app && agent.tags.app !== qData.app) return
    if (qData.tags && qData.tags.length) {
      const match = qData.tags.every(tag => {
        return agent.info.tags.indexOf(tag) > -1
      })
      if (!match) return
    }

    res.write(JSON.stringify(agent.getCacheRecord()) + '\n')
  })

  res.end()
}
