'use strict'

const hyperquest = require('hyperquest')

const util = require('../../util')
const Logger = util.getLogger(__dirname, __filename)

module.exports = notify

function notify (appConfig, payload, fn) {
  const url = appConfig.notificationEndpoint.url

  Logger.debug(`notify via ${url} using license ${appConfig.license.key}`, payload)
  const stream = hyperquest.post(url, {
    agent: appConfig.httpsAgent,
    headers: {
      'x-nsolid-license-key': appConfig.license.key
    }
  })

  stream.end(JSON.stringify(payload))

  stream.on('error', function (err) {
    Logger.error(err, 'notify error')
    fn(err)
  })

  stream.on('response', function handleNotifyResponse (res) {
    Logger.debug('notify response statusCode', res.statusCode)
    return fn()
  })
}
